import { ValidationArgs } from "@vuelidate/core";
import { DefineComponent, Ref } from "vue";
export type FormElementDataType<T> = T | T[];
export interface FormElementItem {
    key: string;
    props: <T>() => T;
    validation?: <S, T extends {
        [key: string]: FormElementDataType<S> | undefined | null;
    }>(model: Ref<T>) => ValidationArgs;
    component: DefineComponent<{}, {}, any>;
}
export interface FormElement {
    layouts: any;
    elements: FormElementItem[];
}
export interface CommonFieldData {
    isReadOnly?: <S, T extends {
        [key: string]: FormElementDataType<S> | undefined | null;
    }>(model: Ref<T>) => boolean;
    isHidden?: <S, T extends {
        [key: string]: FormElementDataType<S> | undefined | null;
    }>(model: Ref<T>) => boolean;
    validation?: <S, T extends {
        [key: string]: FormElementDataType<S> | undefined | null;
    }>(model: Ref<T>) => ValidationArgs;
    mandatory?: boolean;
}
export type FormElementError = {
    [key: string]: {
        [key: string]: string;
    };
};
